#!/bin/bash
# nov 1 2013 - script by don570  to add icon to button
# seven or  ten parameters
# example command - button-svg.sh DejaVu 10 "My Button" .4 "#00DF00" 2 black woman.svg pink black
# ${1} font-family 
# ${2} round corners - recommend 0 to 15 - 0 is square corner
# ${3} quoted textstring
# ${4} opacity of rectangle
# ${5} rectangle color - quoted hex or English word ---> bsvg -c
# ${6} stroke width
STROKECOLOR=${7}
ICON_NAME=${8}
ICON_FILL_COLOR=${9}
ICON_STROKE_COLOR=${10}

[ ! -d  /usr/share/icons/SVGicons ] && echo "/usr/share/icons/SVGicons folder must be created" && exit 0
[ ! -f /usr/share/icons/SVGicons/$8 ] &&  ICON_NAME="none" #check for an icon

FIRST=$(echo `cat /usr/share/icons/SVGicons/$8  2>/dev/null|  grep -n '<g' |   cut -d":" -f1` |  cut -d" " -f1)
BEGINNING=`cat /usr/share/icons/SVGicons/$8   2>/dev/null| sed -n ${FIRST}p | sed 's/<g//' | sed "s/none/$ICON_STROKE_COLOR/"`
let "FIRST=$FIRST+1"


SECOND=$(echo `cat /usr/share/icons/SVGicons/$8  2>/dev/null|  grep -n '</g>' | tail -1` |  cut -d":" -f1)
# icon insertion to button description must be made

grep -q "bohemiancoding" /usr/share/icons/SVGicons/$8  2>/dev/null # modification for CNS icons
if [ "$?" -eq "0" ];then
INSERTION=$(echo -e '<g transform="matrix(1.432412,0.000000,0.000000,1.416394,5.381129,7.943542)"\n '"$BEGINNING"'\n')
INSERTION2=`sed -n "${FIRST},${SECOND}p"  /usr/share/icons/SVGicons/$8 2>/dev/null`
INSERTION2=$(echo "$INSERTION2" | sed -e "s/ fill=\"#000000\"/ fill=\"$ICON_FILL_COLOR\"/")
else
INSERTION=`echo -e '<g \n  transform="translate(3.000000,3.543307)" \n  id="g2"> \n'`
INSERTION2=`sed -n "${FIRST},${SECOND}p"  /usr/share/icons/SVGicons/$8 2>/dev/null`
INSERTION2=$(echo "$INSERTION2" | sed "s/\"fill:#......\"$/\"fill:$ICON_FILL_COLOR\"/" | sed  "/fill:none/!s/fill:[^;]*;/fill:$ICON_FILL_COLOR;/g" |  sed "/stroke:none/!s/stroke:[^;]*;/stroke:$ICON_STROKE_COLOR;/g")
fi


INSERTION_FINAL=`echo -e "$INSERTION \n$INSERTION2"`
[ "$ICON_NAME" = "none" ] && INSERTION_FINAL=""


Y=12
H=36
X1=$(echo "$3"|wc -c)
X2=6
W=$((${X1}*${X2}*90/31+27))
let "DISPLACE=$W/7+28"
[ "$ICON_NAME" = "none" ] && let "DISPLACE=$DISPLACE-11" # correction when no icon
Z=26

# create the SVG image with echo command
  echo '<svg version="1.1">  
      <rect
      style="fill:'$5';fill-opacity:'$4';stroke-width:'$6';stroke:'$STROKECOLOR';stroke-opacity:1;stroke-dasharray:none;"
      width='\"$W\"' height='\"$H\"' rx="'$2'" ry="'$2'" x="1" y="1"/>
           <text style="font-family:'$1';font-size:24;fill-opacity:1"
        x='\"$DISPLACE\"'  y='\"$Z\"' >
'$3'
      </text>
     
		'"$INSERTION_FINAL"'
     
</svg>' > /tmp/img${$}.svg
echo "img${$}.svg is in /tmp"

echo '<window border-width="20"><button relief="2"><input file>"'"/tmp/img${$}.svg"'"</input></button></window>'|gtkdialog -s
rm /tmp/img${$}.svg